# letters menu 
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Uni Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University


set vv(le0)  "Men: [crange $b_letters 1 end]";# "[crange $b_letters 1 end] menu"
set vv(leb1)  "Briefart etc. noch nicht ausgewhlt";# ""
set vv(leb2)  "Dateiname:";# ""
set vv(lec1)  "Auswahlliste fr Brieftyp etc.:";# ""
set vv(lenp)  "Anzahl der Parameter in letter.vst zu klein";# ""
set vv(lenext) "Nchste Eingabe";# ""
#set vv(le)  "";# ""

set letterdir /home/l44/x11/xtemallgdir/letters/

# Tests! Nur die letzte Zeile ist wirksam!
set lettercom "exec emacs zz.tex"               ;# emacs im Vordergrund
set lettercom "exec emacs zz.tex &"             ;# emacs im Hintergrund
set lettercom "exec emacs $main_file$texsuffix" ;# emacs im Vordergrund mit Hauptdatei
set lettercom ".c.1.ed invoke"                  ;# Editor-Button-Invoke
set lettercom ".c.1.la invoke; .c.1.pf invoke"  ;# TeX-Button-, danach Preview-Button-Invoke
set lettercom "latex $main_file$texsuffix; xdvi $main_file";# LaTeX-Lauf, danach xdvi
set lettercom ""                                ;# keine Befehlsausfhrung beim Verlassen
##### if {$lettercom!=""} {signal block SIGCHLD; eval $lettercom; signal unblock SIGCHLD}


proc letters {} {

proc leEditF {sel} {# edit leFile of type leText leComm
 global vv Wle leFile lesep leText leSelStr leNP leNoMod leFileEx

 set leSelStr "$sel"

 set leNP 0;  while {[getvalue $leSelStr $leNP $lesep]!=""} {incr leNP}; incr leNP -1
 if {($leNP<4)&&[winfo exists $Wle.b.t2]} \
	{$Wle.b.t2 configure -text "$vv(aerr): $vv(lenp) ($leNP); $vv(adm)";mybell 3; return}
 TestPut "leNP=<$leNP>"

 set leText(0) "% [getvalue $leSelStr 0 $lesep]  $leNoMod"

 set leComm(1) "[getvalue $leSelStr 1 $lesep]"
 for {set np 3} {$np<$leNP} {incr np}  {
   if {$leFileEx==0} {
     set leText($np) ""
   } else {
     set leText($np) "Text leText($np) noch zu ermitteln"
   }
   set leTCom($np) "[lindex [getvalue $leSelStr $np $lesep] 5]"
 }
 set leComm($leNP) "[getvalue $leSelStr $leNP $lesep]"


 destroy $Wle.a.q
 set CtrlWleanext w
 button $Wle.a.next -text "^$CtrlWleanext  $vv(lenext)" -command "leWleanext"
 bind $Wle <Control-$CtrlWleanext> {leWleanext}
 pack configure $Wle.a.next -side left -padx 3 -pady 3

 leExecPar 3; # all other paramters>2 are done by proc "leWleanext" (binding to $Wle.a.next)
}

proc leWleanext {} {
 global Wle lesep letterdir leFile leNP leSelStr lePar leParSelStr leParType
 #
 # get text from window just terminated (lePar)
 if {$leParType=="entry"} {
   set text [$Wle.c.f.t get]
 } elseif {$leParType=="text"} {
   set l [$Wle.c.f.t get "end -1c" end]
   if {$l=="\n"} {set text [$Wle.c.f.t get 1.0 "end-1c"]} {set text [$Wle.c.f.t get 1.0 end]}
 }
 TestPut "<$lePar><$text>"
 #
 # post-manipulation of text (lePar)
 #
 # call next entry window (lePar+1)
 if {$lePar<$leNP-1} {leExecPar [expr $lePar+1]} else {leExecFin}
}

proc leExecPar {p} {# edit parameter $p
 global vv Wle lesep leSelStr lePar leParSelStr leParType main_file texsuffix lesep
 set lePar $p
 set leParSelStr [getvalue $leSelStr $p $lesep]
 TestPut 3 "Par$p=<$leParSelStr>"
 $Wle.b.t1 configure -text \
	"[getvalue $leSelStr 0 $lesep] ($main_file$texsuffix); [lindex $leParSelStr 0] "
 set h "[lindex [lindex $leParSelStr 2] 0]"; set w "[lindex [lindex $leParSelStr 2] 1]"
 if [winfo exists $Wle.c.f] {destroy $Wle.c.f}
 frame $Wle.c.f; pack $Wle.c.f
 if {$h==1} {
   set leParType entry
   entry $Wle.c.f.t -width $w; pack configure $Wle.c.f.t
   bind $Wle.c.f.t <Return> {focus $Wle}
 } else {
   set leParType text
   text $Wle.c.f.t -height $h -width $w; pack configure $Wle.c.f.t
   ##### $Wle.c.f.t insert insert "$p\n$leParSelStr"
 }
 focus $Wle.c.f.t
 $Wle.b.t2 configure -text "[lindex $leParSelStr 1]"
 update
}

proc leExecFin {} {
 global Wle leFile lesep leSelStr leNP leText leComm letterdir

 TestPut "leText(0)=<$leText(0)>"
 TestPut "leComm(1)=<$leComm(1)>"
 leExecF " echo $leText(0)" $leFile
 for {set np 3} {$np<$leNP} {incr np}  {
   TestPut "leText($np)=<$leText($np)>"
   TestPut "leComm($np)=<$leComm($np)>"
 }
 TestPut "leComm($leNP)=<$leComm($leNP)>"

 leExecF
 eval leExecF \"$leComm(1)\"
 eval leExecF \"$leComm($leNP)\"

 leExecF "$leCF" $leFile; destros $Wle; unlock_list
}

proc leExecF {cmd} {# executes cmd via exec and appends result to file leFile
 global leFile
 TestPut 2 "<$cmd>"
 if {[string trim $cmd]!=""} \
	{signal block SIGCHLD; eval exec $cmd >> $leFile; signal unblock SIGCHLD}
}

proc leEditExF {} {# re-edit existing file
 global leFile main_file texsuffix
 puts stdout "Datei existiert bereits; Editieren realisieren!"; mybell 4; unlock_list
 puts stdout "Umkopieren $leFile ---> $main_file$texsuffix"
##################
#  ...    look for type (in existing file, line 1) and then look in letters.vst --> sel
 set sel ""
#################
 leEditF "$sel"
}

proc leSelected {sel} {# letter type selected (new file)
 TestPut 3 "<<$sel>>"
 leEditF "$sel"
}


proc leSelectT {} {# creates "select letter type" window
 global Wle vv main_file texsuffix lesep hlp_dir

 proc leWleaq {} {global Wle; destros $Wle; unlock_list}; # ends letter window

 toplevel_init $Wle "$vv(le0)" 300 300;  set wsb 40;  set nlm 14

 # top buttons
 frame $Wle.a;  pack configure $Wle.a -pady 3 -anchor nw
 button $Wle.a.q -text "$vv(xt31)" -command "leWleaq"
 pack configure $Wle.a.q -side left -padx 3 -pady 3


 # display area
 frame $Wle.b; pack configure $Wle.b -pady 3 -anchor nw
 label $Wle.b.t1 -text "$vv(leb1); $vv(leb2) $main_file$texsuffix" -width 50 -anchor w
 pack configure $Wle.b.t1 -pady 10 -anchor w
 label $Wle.b.t2 -anchor w; pack configure $Wle.b.t2 -anchor w -ipadx 2

 # select box/buttons
 frame $Wle.c; pack configure $Wle.c -anchor w -ipadx 2
 CreateLSBox $Wle.c $vv(lec1) top $wsb $nlm 2 "" "" \
	"$lesep" [vst2list "letters.vst" 1 "$lesep" "" leSel_v] leSelected "" leWleae

 focus $Wle
}


global vv b_letters lesep main_file texsuffix leFile leFileEx leNoMod

set lesep [getsep letters.vst]
set leNoMod "(don't modify this line)"

set leFile $main_file$texsuffix
if {[file exists $leFile]&&([file size $leFile]>0)} {set leFileEx 1; leEditExF} \
else						    {set leFileEx 0; leSelectT}
}
